	.file	"itof.S"
	.text
	.align	2
	.global	itof
	.type	itof, %function
	
itof:
	cmp 	r0, #0		@ als erstes auf Null berprfen
	bxeq	lr			@ wenn es Null war, sind wir fertig
	movmi	r1, #1		@ Vorzeichen in r1 speichern
	movpl	r1, #0		@ positives vorzeichen ergibt 0	
	rsbmi	r0, r0, #0	@ Wenn negative Zahl, dann zu psoitiver Zahl wandeln
	
	mov 	r2, #0x9F	@ Offset dazu addieren 0x7f + 32 (maximale Anzahl der Shifts)
loop:
	movs	r0, r0, lsl #1	@ so lange nach links schieben, bis erstes Bit im Carry
							@ dadurch werden wir auch gleich das hidden Bit los
	sub		r2, #1			@ vom Exponenten jeweils 1 abziehen
	bcc		loop
	
	mov		r0, r0, lsr #9		@ Mantisse in die richtige Position bringen
	add		r0, r0, r2, lsl #23	@ Exponent einfgen
	orr 	r0, r0, r1, lsl #31	@ Vorzeichen einfgen
	
	bx		lr					@ fertig, Ergebnis steht in r0
	.size	itof, .-itof
	
